import java.applet.*;
import java.awt.*;
import java.awt.image.*;

/*
	 <applet code="Tree" width=200 height=200>
	 <param name="initialdegree" value="90">
	 <param name="initiallength" value="30">
	 <param name="initialloopnum" value="10">
	 <param name="right" value="70">
	 <param name="left" value="70">
	 </applet>
 */

public class Tree extends Applet{

	int initialdegree, initiallength, initialloopnum;
	int right, left;

	public void init(){
		initialdegree = Integer.parseInt(getParameter("initialdegree"));
		initialloopnum = Integer.parseInt(getParameter("initialloopnum"));
		initiallength = Integer.parseInt(getParameter("initiallength"));
		right = (int)(Integer.parseInt(getParameter("right"))*Math.random());
		left = (int)(Integer.parseInt(getParameter("left"))*Math.random());
	}

	public void paint(Graphics g){
		Dimension d = getSize();

		g.setColor(Color.white);
		g.fillRect(0, 0, d.width, d.height);
		g.setColor(Color.black);
		fractal(g, d.width/2, d.height*4/5, initialdegree, initialloopnum, initiallength);
	}

	public void fractal(Graphics g, int x, int y, int degree, int loopnum, int length){
		int nextX, nextY;

		nextX = x + (int)(Math.cos(Math.toRadians((double)degree))*length);
		nextY = y - (int)(Math.sin(Math.toRadians((double)degree))*length);

		g.drawLine(x, y, nextX, nextY);

		if(loopnum!=0){
			fractal(g, nextX, nextY, degree - right, loopnum - 1, (int)(length * 0.8));
			fractal(g, nextX, nextY, degree + left, loopnum - 1, (int)(length * 0.8));
		}
	}

}	

